diff --git a/.gitlab/ci.sh b/.gitlab/ci.sh
index 269d76e63394c17b8346cfc57e88789ad639e720..824699e9c7bb1462f04ff2d581e327ae1bac4bf2 100755
--- a/.gitlab/ci.sh
+++ b/.gitlab/ci.sh
@@ -492,7 +492,7 @@ function test_make() {
 
   check_release_build
 
-  run "$MAKE" test_bindist TEST_PREP=YES
+  run "$MAKE" test_bindist TEST_PREP=YES TEST_PROF=${RELEASE_JOB:-}
   (unset $(compgen -v | grep CI_*);
     run "$MAKE" V=0 VERBOSE=1 test \
       THREADS="$cores" \
@@ -588,6 +588,13 @@ function test_hadrian() {
       fail "Test compiler has a different BIGNUM_BACKEND ($test_compiler_backend) thean requested ($BIGNUM_BACKEND)"
     fi
 
+    # If we are doing a release job, check the compiler can build a profiled executable
+    if [ "${RELEASE_JOB:-}" == "yes" ]; then
+      echo "main = print ()" > proftest.hs
+      run ${test_compiler} -prof proftest.hs || fail "hadrian profiled libs test"
+      rm proftest.hs
+    fi
+
     run_hadrian \
       test \
       --summary-junit=./junit.xml \
diff --git a/bindisttest/Makefile b/bindisttest/Makefile
index e49172c77d4a9336e80f0d23c5c57fd81064b06d..3df55a91671544360095fddb70096ec2769e0c6a 100644
--- a/bindisttest/Makefile
+++ b/bindisttest/Makefile
@@ -50,6 +50,12 @@ endif
 	$(CONTEXT_DIFF) output expected_output
 # Without --no-user-package-db we might pick up random packages from ~/.ghc
 	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check --no-user-package-db
+ifeq "$(TEST_PROF)" "yes"
+	$(BIN_DIST_INST_DIR)/bin/ghc --make -prof HelloWorld
+	./HelloWorld > output
+	$(CONTEXT_DIFF) output expected_output
+endif
+
 
 clean distclean:
 	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)